function [f] = medfilt(n,image)
//
// Performs median filtration
// n - size of window
// image - source array
//
// Created by D. Ushakov (dushakov@gmail.com)
//

// Window
win = zeros(1,n*n);
// Sorting window
sorting = zeros(1:n*n);
f = image;
s = size(image);

dn = fix(n/2);
if dn == n/2 then
  error('First argument must be even');
end;

printf('This may take a while...');
select type(image)
  case 1 then   // 2D array
    for i = dn+1:s(1)-dn
      for j = dn+1:s(2)-dn
        // Move current window
        w = 1;
        for di = -dn:dn
          for dj = -dn:dn
            win(w) = image(i+di,j+dj);
            w = w+1;
          end;
        end;
        sorting = sort(win);
        f(i,j) = uint8(sorting(fix((n*n)/2)+1));
      end;
    end;
  case 17 then    // 3D array
    if s(3) ~= 3 then
      error('RGB image must have 3rd dimension equal to 3.');
    end;
    for k = 1:3
      for i = dn+1:s(1)-dn
        for j = dn+1:s(2)-dn
          // Move current window
          w = 1;
          for di = -dn:dn
            for dj = -dn:dn
              win(w) = image(i+di,j+dj,k);
              w = w+1;
            end;
          end;
          sorting = sort(win);
          f(i,j,k) = uint8(sorting(5));
        end;
      end;
    end;
  else
    error('Argument of invalid type.');
end;
endfunction
