function [f] = rot90(x,k)
//
// Rotate matrix 90
// B = rot90(A,k) rotates matrix A counterclockwise by k*90
// degrees, where k is an integer.
//
// Author: Ushakov Dmitriy <dushakov@gmail.com>

if argn(2) == 1 then
  k = 1   // Default 90
elseif k > 4 then
  k = modulo(k,4)
end

// Return the same matrix
if modulo(abs(k),4) == 0 then
  f=return(x)
end

y=x
if k > 0 then
  for i = 1:k
    s = size(y)
    for j = 1:s(1)
      for t = s(2):-1:1
        f(s(2)+1-t,j) = y(j,t)
      end
    end
    y = f
    clear f
  end
else
  k = abs(k)
  for i = 1:k
    s = size(y)
    for j = s(1):-1:1
      f(:,s(1)+1-j) = y(j,:)'
    end
    y = f
    clear f
  end
end

f = y

endfunction
